/*
								+---------------------------------+
								|                                 |
								| ***  Multi-mon win support  *** |
								|                                 |
								|  Copyright   -tHE SWINe- 2006  |
								|                                 |
								|           Monitors.h            |
								|                                 |
								+---------------------------------+
*/

#ifndef __MULTI_MON_INCLUDED
#define __MULTI_MON_INCLUDED

struct TMonitorInfo {
	bool b_valid, b_on;
	int n_x, n_y;
	int n_width, n_height;
	char p_s_name[128];
};

struct TMultimonInfo {
protected:
	int m_n_monitor_num;
	TMonitorInfo *m_p_monitor;
	TMonitorInfo m_t_full_window; // size and position of the largest window covering every monitor
	TMonitorInfo m_t_full_on_window; // largest window covering every monitor that is switched on

public:
	TMultimonInfo();
	~TMultimonInfo();

	bool Update_Monitors();

	int n_Monitor_Num() const;
	const TMonitorInfo *p_Monitor(int n_index) const;
	const TMonitorInfo &t_Full_Window(bool b_include_shutdown_monitors) const;

protected:
	static BOOL CALLBACK MonCallback(HMONITOR h_monitor, HDC h_dc, LPRECT p_rect, LPARAM n_l_param);
};

#endif //__MULTI_MON_INCLUDED
